Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.beans.factory.config
Class MethodInvokingFactoryBean

    java.lang.Object
      org.springframework.util.MethodInvoker
          org.springframework.beans.support.ArgumentConvertingMethodInvoker
              org.springframework.beans.factory.config.MethodInvokingFactoryBean

All Implemented Interfaces:
  Aware, BeanClassLoaderAware, BeanFactoryAware, FactoryBean<java.lang.Object>, InitializingBean

    public class MethodInvokingFactoryBean

extends ArgumentConvertingMethodInvoker
implements FactoryBean<java.lang.Object>, BeanClassLoaderAware, BeanFactoryAware, InitializingBean

`FactoryBean` which returns a value which is the result of a static or instance method invocation. For most use cases it is better to just use the container's built-in factory method support for the same purpose, since that is smarter at converting arguments. This factory bean is still useful though when you need to call a method which doesn't return any value (for example, a static class method to force some sort of initialization to happen). This use case is not supported by factory methods, since a return value is needed to obtain the bean instance.

Note that as it is expected to be used mostly for accessing factory methods, this factory by default operates in a singleton fashion. The first request to `getObject()` by the owning bean factory will cause a method invocation, whose return value will be cached for subsequent requests. An internal `singleton` property may be set to "false", to cause this factory to invoke the target method each time it is asked for an object.

A static target method may be specified by setting the `targetMethod` property to a String representing the static method name, with `targetClass` specifying the Class that the static method is defined on. Alternatively, a target instance method may be specified, by setting the `targetObject` property as the target object, and the `targetMethod` property as the name of the method to call on that target object. Arguments for the method invocation may be specified by setting the `arguments` property.

This class depends on `afterPropertiesSet()` being called once all properties have been set, as per the InitializingBean contract.

An example (in an XML based bean factory definition) of a bean definition which uses this class to call a static factory method:

     <bean id="myObject" class="org.springframework.beans.factory.config.MethodInvokingFactoryBean">
       <property name="staticMethod"><value>com.whatever.MyClassFactory.getInstance</value></property>
     </bean>

An example of calling a static method then an instance method to get at a Java system property. Somewhat verbose, but it works.

     <bean id="sysProps" class="org.springframework.beans.factory.config.MethodInvokingFactoryBean">
       <property name="targetClass"><value>java.lang.System</value></property>
       <property name="targetMethod"><value>getProperties</value></property>
     </bean>

     <bean id="javaVersion" class="org.springframework.beans.factory.config.MethodInvokingFactoryBean">
       <property name="targetObject"><ref local="sysProps"/></property>
       <property name="targetMethod"><value>getProperty</value></property>
       <property name="arguments">
         <list>
           <value>java.version</value>
         </list>
       </property>
     </bean>

Since:
  21.11.2003
Author:
  Colin Sampaleanu, Juergen Hoeller

Constructor Summary
`MethodInvokingFactoryBean()`

Method Summary
`void` | `afterPropertiesSet()` Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).
`protected TypeConverter` | `getDefaultTypeConverter()` Obtain the TypeConverter from the BeanFactory that this bean runs in, if possible.
`java.lang.Object` | `getObject()` Returns the same value each time if the singleton property is set to "true", otherwise returns the value returned from invoking the specified method on the fly.
`java.lang.Class<?>` | `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
`boolean` | `isSingleton()` Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?
`protected java.lang.Class` | `resolveClassName(java.lang.String className)` Resolve the given class name into a Class.
`void` | `setBeanClassLoader(java.lang.ClassLoader classLoader)` Callback that supplies the bean `class loader` to a bean instance.
`void` | `setBeanFactory(BeanFactory beanFactory)` Callback that supplies the owning factory to a bean instance.
`void` | `setSingleton(boolean singleton)` Set if a singleton should be created, or a new object on each request else.

Methods inherited from class org.springframework.beans.support.ArgumentConvertingMethodInvoker
`doFindMatchingMethod, findMatchingMethod, getTypeConverter, registerCustomEditor, setTypeConverter`

Methods inherited from class org.springframework.util.MethodInvoker
`getArguments, getPreparedMethod, getTargetClass, getTargetMethod, getTargetObject, getTypeDifferenceWeight, invoke, isPrepared, prepare, setArguments, setStaticMethod, setTargetClass, setTargetMethod, setTargetObject`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### MethodInvokingFactoryBean

    public MethodInvokingFactoryBean()

Method Detail

### setSingleton

    public void setSingleton(boolean singleton)

  Set if a singleton should be created, or a new object on each request else. Default is "true".

### isSingleton

    public boolean isSingleton()

  Description copied from interface: `FactoryBean`
  Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

  NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

  The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

  NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

  Specified by:
    `isSingleton` in interface `FactoryBean<java.lang.Object>`
  Returns:
    whether the exposed object is a singleton
  See Also:
    `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`

### setBeanClassLoader

    public void setBeanClassLoader(java.lang.ClassLoader classLoader)

  Description copied from interface: `BeanClassLoaderAware`
  Callback that supplies the bean `class loader` to a bean instance.

  Invoked after the population of normal bean properties but before an initialization callback such as `InitializingBean's` `InitializingBean.afterPropertiesSet()` method or a custom init-method.

  Specified by:
    `setBeanClassLoader` in interface `BeanClassLoaderAware`
  Parameters:
    `classLoader` - the owning class loader; may be `null` in which case a default `ClassLoader` must be used, for example the `ClassLoader` obtained via `ClassUtils.getDefaultClassLoader()`

### resolveClassName

    protected java.lang.Class resolveClassName(java.lang.String className)
                                        throws java.lang.ClassNotFoundException

  Description copied from class: `MethodInvoker`
  Resolve the given class name into a Class.

  The default implementations uses `ClassUtils.forName`, using the thread context class loader.

  Overrides:
    `resolveClassName` in class `MethodInvoker`
  Parameters:
    `className` - the class name to resolve
  Returns:
    the resolved Class
  Throws:
    `java.lang.ClassNotFoundException` - if the class name was invalid

### setBeanFactory

    public void setBeanFactory(BeanFactory beanFactory)

  Description copied from interface: `BeanFactoryAware`
  Callback that supplies the owning factory to a bean instance.

  Invoked after the population of normal bean properties but before an initialization callback such as `InitializingBean.afterPropertiesSet()` or a custom init-method.

  Specified by:
    `setBeanFactory` in interface `BeanFactoryAware`
  Parameters:
    `beanFactory` - owning BeanFactory (never `null`). The bean can immediately call methods on the factory.
  See Also:
    `BeanInitializationException`

### getDefaultTypeConverter

    protected TypeConverter getDefaultTypeConverter()

  Obtain the TypeConverter from the BeanFactory that this bean runs in, if possible.

  Overrides:
    `getDefaultTypeConverter` in class `ArgumentConvertingMethodInvoker`
  See Also:
    `ConfigurableBeanFactory.getTypeConverter()`

### afterPropertiesSet

    public void afterPropertiesSet()
                            throws java.lang.Exception

  Description copied from interface: `InitializingBean`
  Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).

  This method allows the bean instance to perform initialization only possible when all bean properties have been set and to throw an exception in the event of misconfiguration.

  Specified by:
    `afterPropertiesSet` in interface `InitializingBean`
  Throws:
    `java.lang.Exception` - in the event of misconfiguration (such as failure to set an essential property) or if initialization fails.

### getObject

    public java.lang.Object getObject()
                               throws java.lang.Exception

  Returns the same value each time if the singleton property is set to "true", otherwise returns the value returned from invoking the specified method on the fly.

  Specified by:
    `getObject` in interface `FactoryBean<java.lang.Object>`
  Returns:
    an instance of the bean (can be `null`)
  Throws:
    `java.lang.Exception` - in case of creation errors
  See Also:
    `FactoryBeanNotInitializedException`

### getObjectType

    public java.lang.Class<?> getObjectType()

  Return the type of object that this FactoryBean creates, or `null` if not known in advance.

  Specified by:
    `getObjectType` in interface `FactoryBean<java.lang.Object>`
  Returns:
    the type of object that this FactoryBean creates, or `null` if not known at the time of the call
  See Also:
    `ListableBeanFactory.getBeansOfType(java.lang.Class)`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD